//
//  Controller.m
//  SearchHistory
//
//  Created by KOYAMA Yoshiaki on Tue Jun 22 2004.
//  Copyright (c) 2004 KOYAMA Yoshiaki. All rights reserved.
//

#import "Controller.h"

@implementation Controller

#pragma mark -
#pragma mark /// delegate ///

- (BOOL)windowShouldClose:(id)sender {
 //   [NSApp terminate:self];
    return YES;
}

- (void)applicationDidFinishLaunching:(NSNotification *)aNotification {    
	NSFileManager *manager = [NSFileManager defaultManager];
	NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
	NSDictionary *safariDictionary;
	NSMutableDictionary *searchHistoryDictionary;
	NSString *databasePath;
	NSString *safariPlistPath;
//	int i;

	safariPlistPath = NSHomeDirectory();
	safariPlistPath = [safariPlistPath stringByAppendingPathComponent:@"Library/Preferences/com.apple.Safari.plist"];

	if ([manager fileExistsAtPath:safariPlistPath] == YES) {		

		safariDictionary = [NSDictionary dictionaryWithContentsOfFile:safariPlistPath];
		[safariDictionary retain];
		_searchSafariArray = [safariDictionary valueForKey:@"RecentSearchStrings"];

		if (_searchSafariArray == nil) {
			_searchSafariArray = [NSArray array]; 
		}
/*		NSLog(@"count = %d", [_searchSafariArray count]);
		for (i=0; i<[_searchSafariArray count]; i++) {
			NSLog(@"*");
//			NSLog(@"%@", [_searchSafariArray objectAtIndex:i]);
		}
*/
	} else {
		_searchSafariArray = [NSArray array]; 
	}
	
	[_searchSafariArray retain];

	databasePath = NSHomeDirectory();
	databasePath = [databasePath stringByAppendingPathComponent:@"Documents/SearchHistoryDatabase"];

	if ([manager fileExistsAtPath:databasePath] == YES) {		

		searchHistoryDictionary = [NSUnarchiver unarchiveObjectWithFile:databasePath];
		_searchSHistoryArray = [searchHistoryDictionary valueForKey:@"RecentSearchStrings"];
		_searchDatabase = [searchHistoryDictionary valueForKey:@"SearchHistory"];

/*
		NSLog(@"-----------------------------------------");
		for (i=0; i<[_searchSHistoryArray count]; i++) {
			NSLog(@"%@", [_searchSHistoryArray objectAtIndex:i]);
		}
*/
	} else {
		_searchSHistoryArray = [NSArray array]; 
		_searchDatabase = [NSMutableArray array];
	}


	[_searchSHistoryArray retain];
	[_searchDatabase retain];

	// データベースの作成
	[self makeSearchDatabase];

	[self setSortDescriptor];
	[_tableView reloadData];

	searchHistoryDictionary = [NSMutableDictionary dictionary];
	[searchHistoryDictionary setObject:_searchSafariArray forKey:@"RecentSearchStrings"];
	[searchHistoryDictionary setObject:_searchDatabase forKey:@"SearchHistory"];

	[NSArchiver archiveRootObject:searchHistoryDictionary toFile:databasePath];

	// ディスプレイの中央に移動
	[_preferencesWindow center];

	if ([defaults boolForKey:@"InvisibleWindow"] == YES) {
		[_switch setState:NSOnState];
	} else {
		[_mainWindow makeKeyAndOrderFront:self];
	}
}

#pragma mark -
#pragma mark /// function ///

// データベースから選択した検索文字列を削除
- (IBAction)deleteHistory:(id)sender {
	NSFileManager *manager = [NSFileManager defaultManager];
//	NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
	NSMutableDictionary *searchHistoryDictionary;
	NSString *databasePath;
	NSString *history, *deleteHistory;
	NSMutableDictionary *search, *deleteSearch;
	NSArray *searchSHistoryArray;
	int row;
	int i;

	row = [_tableView selectedRow];

	databasePath = NSHomeDirectory();
	databasePath = [databasePath stringByAppendingPathComponent:@"Documents/SearchHistoryDatabase"];

	if (([manager fileExistsAtPath:databasePath] == YES) && (row != -1)){		
		search = [_searchDatabase objectAtIndex:row];
		history = [search objectForKey:@"History"];

		searchHistoryDictionary = [NSUnarchiver unarchiveObjectWithFile:databasePath];
		searchSHistoryArray = [searchHistoryDictionary valueForKey:@"RecentSearchStrings"];
		_searchDatabase = [searchHistoryDictionary valueForKey:@"SearchHistory"];

		[_searchSHistoryArray retain];
		[_searchDatabase retain];

		for (i=0; i<[_searchDatabase count]; i++) {
			deleteSearch = [_searchDatabase objectAtIndex:i];
			deleteHistory = [deleteSearch objectForKey:@"History"];
			if ([deleteHistory isEqualToString:history] == YES) {
				[_searchDatabase removeObjectAtIndex:i];
				break;
			}
		}

		[_tableView reloadData];

		searchHistoryDictionary = [NSMutableDictionary dictionary];
		[searchHistoryDictionary setObject:searchSHistoryArray forKey:@"RecentSearchStrings"];
		[searchHistoryDictionary setObject:_searchDatabase forKey:@"SearchHistory"];

		[NSArchiver archiveRootObject:searchHistoryDictionary toFile:databasePath];
	} 	
}
 
// テーブルビューのカラムにソートのマークを付けるために NSSortDescriptor　を設定しています。
// 設定してもソートされないので、別にソートする部分を追加しています。
- (void)setSortDescriptor {
	NSTableColumn *column;
	NSSortDescriptor *sortHistoryDescriptor;
	NSSortDescriptor *sortCountDescriptor;
	NSSortDescriptor *sortDateDescriptor;
	NSArray *sortArray;

	sortDateDescriptor = [[NSSortDescriptor alloc] initWithKey:@"Date" ascending:NO];
	sortHistoryDescriptor = [[NSSortDescriptor alloc] initWithKey:@"History" ascending:YES];
	sortCountDescriptor = [[NSSortDescriptor alloc] initWithKey:@"Count" ascending:YES];

	sortArray = [NSArray arrayWithObjects:sortHistoryDescriptor, sortCountDescriptor,nil];
	sortArray = [NSArray arrayWithObjects:sortDateDescriptor, sortHistoryDescriptor ,sortCountDescriptor, nil];

	[_tableView setSortDescriptors:sortArray];

    column = [_tableView tableColumnWithIdentifier:@"Date"];
	[column setSortDescriptorPrototype:sortDateDescriptor];

    column = [_tableView tableColumnWithIdentifier:@"History"];
	[column setSortDescriptorPrototype:sortHistoryDescriptor];

    column = [_tableView tableColumnWithIdentifier:@"Count"];
	[column setSortDescriptorPrototype:sortCountDescriptor];

	// 実際のソート
	[_searchDatabase sortUsingDescriptors:sortArray];


//	NSLog (@"%@", [column sortDescriptorPrototype]);
 }

// 以前の検索履歴に語句があるか
- (BOOL)checkSearchHistory:(NSString *)history {
	int i;
	BOOL flag = NO;
	NSString *historySH;
	
	for (i=0; i<[_searchSHistoryArray count]; i++) {
		historySH = [_searchSHistoryArray objectAtIndex:i];
		if ([historySH isEqualToString:history] == YES) {
//NSLog(@"EQUAL");
			flag = YES;
			break;
		}
	}

	return flag;
}

// データーベースの作成
- (void)makeSearchDatabase {    
	NSString *history;
	int i, max;

	max = [_searchSafariArray count];
	for (i=max-1; i>=0; i--) {
		history = [_searchSafariArray objectAtIndex:i];

		if ([self checkSearchHistory:history] == NO) {
//NSLog(@"Make");
			[self addSearchDatabase:history];
		}
	}
}

// データーベースに追加
- (void)addSearchDatabase:(NSString *)history {
	NSMutableDictionary *search;
	NSMutableDictionary *addSearch;
	int index = 0;
	NSNumber *countNumber;
	BOOL flag = NO;
	int count = 1;
	int i;
	NSString *historyDatabase;

	// 語句がデーターベースに存在するか
	// データーベースのレコードの数が多いと問題があるかもしれません
	for (i=0; i<[_searchDatabase count]; i++) {
		search = [_searchDatabase objectAtIndex:i];
		historyDatabase = [search objectForKey:@"History"];
		if ([historyDatabase isEqualToString:history] == YES) {
			index = i;
			countNumber = [search objectForKey:@"Count"];
			count = [countNumber intValue];
			flag = YES;
			break;
		}
	}

	if (flag == YES) {
		[_searchDatabase removeObjectAtIndex:index];
		count++;
//NSLog(@"Exist");
	} else {
//NSLog(@"No");
	}

	// 実際に追加
	addSearch = [NSMutableDictionary dictionary];
	[addSearch setObject:history forKey:@"History"];
	[addSearch setObject:[NSNumber numberWithInt:count] forKey:@"Count"];
	[addSearch setObject:[NSDate date] forKey:@"Date"];

	[_searchDatabase addObject:addSearch];
//	[_searchDatabase insertObject:addSearch atIndex:0];
}

- (NSMutableArray *)database {
	return _searchDatabase;
}

// 起動時にウインドウを表示するかの設定
- (IBAction)switchWindow:(id)sender {
	NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];

	if ([_switch state] == NSOnState) {
		[defaults setBool:YES forKey:@"InvisibleWindow"];
	} else {
		[defaults setBool:NO forKey:@"InvisibleWindow"];
	}

	[defaults synchronize];
}

@end
