//
//  DataSource.m
//  SearchHistory
//
//  Created by KOYAMA Yoshiaki on Mon Jun 28 2004.
//  Copyright (c) 2004 KOYAMA Yoshiaki. All rights reserved.
//

#import "DataSource.h"
#import "Controller.h"

@implementation DataSource

#pragma mark -
#pragma mark /// Initial ///

- (id)init {
    self = [super init];

	_historyAscend = YES;
	_countAscend = YES;
	_dateAscend = YES;

    return self;
}

- (void)awakeFromNib {
    NSFont *aFont;
    NSTableColumn *column;
	NSCell *cell;

	aFont = [NSFont fontWithName:@"HiraKakuPro-W3" size:10];

    column = [_tableView tableColumnWithIdentifier:@"Date"];
	[column setEditable:NO];
    cell = [column dataCell];
	[cell setFont:aFont];
			
    column = [_tableView tableColumnWithIdentifier:@"History"];
	[column setEditable:NO];
    cell = [column dataCell];
	[cell setFont:aFont];
	
    column = [_tableView tableColumnWithIdentifier:@"Count"];
	[column setEditable:NO];
    cell = [column dataCell];
	[cell setFont:aFont];

	[_tableView setTarget:self];
	[_tableView setDoubleAction:@selector(openDoubleFile:)];
}

#pragma mark -
#pragma mark /// DataSource ///

/*
	NSTableView
*/

- (int)numberOfRowsInTableView:(NSTableView *)aTableView {
    return [[_controller database] count];
}

- (id)tableView:(NSTableView *)aTableView
    objectValueForTableColumn:(NSTableColumn *)aTableColumn
    row:(int)rowIndex
{
	NSMutableArray *array;	
	NSMutableDictionary *search;

	array = [_controller database];

	if (rowIndex >= 0 && rowIndex < [array count]) { 
		search = [array objectAtIndex:rowIndex];
		if ([[aTableColumn identifier] isEqual:@"History"]) {
            return [search objectForKey:@"History"];
		} else if ([[aTableColumn identifier] isEqual:@"Count"]) {
				return [search objectForKey:@"Count"];
		} else if ([[aTableColumn identifier] isEqual:@"Date"]) {
				return [search objectForKey:@"Date"];

		}
	}

    return nil;
}

- (void)tableView:(NSTableView *)tableView sortDescriptorsDidChange:(NSArray *)oldDescriptors {
/*    NSTableColumn *column;			

    column = [_tableView tableColumnWithIdentifier:@"History"];
 	NSLog (@"[%@]", [column sortDescriptorPrototype]);
*/
}

//- (void)tableView:(NSTableView *)tableView didClickTableColumn:(NSTableColumn *)tableColumn
- (BOOL)tableView:(NSTableView *)aTableView shouldSelectTableColumn:(NSTableColumn *)aTableColumn {
	NSSortDescriptor *sortHistoryAscendDescriptor;
	NSSortDescriptor *sortHistoryDescendDescriptor;
	NSSortDescriptor *sortCountAscendDescriptor;
	NSSortDescriptor *sortCountDescendDescriptor;
	NSSortDescriptor *sortDateAscendDescriptor;
	NSSortDescriptor *sortDateDescendDescriptor;

	sortDateAscendDescriptor = [[[NSSortDescriptor alloc] initWithKey:@"Date" ascending:YES] autorelease];
	sortDateDescendDescriptor = [[[NSSortDescriptor alloc] initWithKey:@"Date" ascending:NO] autorelease];
	
	sortHistoryAscendDescriptor = [[[NSSortDescriptor alloc] initWithKey:@"History" ascending:YES] autorelease];
	sortHistoryDescendDescriptor = [[[NSSortDescriptor alloc] initWithKey:@"History" ascending:NO] autorelease];

	sortCountAscendDescriptor = [[[NSSortDescriptor alloc] initWithKey:@"Count" ascending:YES] autorelease];
	sortCountDescendDescriptor = [[[NSSortDescriptor alloc] initWithKey:@"Count" ascending:NO] autorelease];

	if ([[aTableColumn identifier] isEqual:@"History"] == YES) {
		if (_historyAscend == YES) {
			[[_controller database] sortUsingDescriptors:[NSArray arrayWithObjects:sortHistoryAscendDescriptor, nil]];
		} else {
			[[_controller database] sortUsingDescriptors:[NSArray arrayWithObjects:sortHistoryDescendDescriptor, nil]];
		}
		if (_historyAscend == YES) {
			_historyAscend = NO;
		} else {
			_historyAscend = YES;
		}	
	} else if ([[aTableColumn identifier] isEqual:@"Count"] == YES) {
		if (_countAscend == YES) {
			[[_controller database] sortUsingDescriptors:[NSArray arrayWithObjects:sortCountAscendDescriptor, nil]];
		} else {
			[[_controller database] sortUsingDescriptors:[NSArray arrayWithObjects:sortCountDescendDescriptor, nil]];
		}
		if (_countAscend == YES) {
			_countAscend = NO;
		} else {
			_countAscend = YES;
		}	
	} else if ([[aTableColumn identifier] isEqual:@"Date"] == YES) {
		if (_dateAscend == YES) {
			[[_controller database] sortUsingDescriptors:[NSArray arrayWithObjects:sortDateAscendDescriptor, nil]];
		} else {
			[[_controller database] sortUsingDescriptors:[NSArray arrayWithObjects:sortDateDescendDescriptor, nil]];
		}
		if (_dateAscend == YES) {
			_dateAscend = NO;
		} else {
			_dateAscend = YES;
		}	

	}

	[_tableView reloadData];

	return NO;
}

- (BOOL)tableView:(NSTableView *)aTableView shouldSelectRow:(int)rowIndex {
/*	NSMutableArray *array;	
	NSMutableDictionary *search;
    NSTableColumn *column;			
	
	array = [_controller database];

	if (rowIndex >= 0 && rowIndex < [array count]) { 
		search = [array objectAtIndex:rowIndex];
		NSLog(@"index %d", rowIndex);
	}

    column = [_tableView tableColumnWithIdentifier:@"History"];
 	NSLog (@"%@", [column sortDescriptorPrototype]);
*/	
	return YES;
}

#pragma mark -
#pragma mark /// Search ///

// Google日本語のページを検索
- (void)openDoubleFile:(id)sender {
	NSWorkspace *wspace = [NSWorkspace sharedWorkspace];
	NSString *history;
	NSMutableArray *array;	
	NSMutableDictionary *search;
	int row;
	NSURL *url;
	NSString *urlString;
	
	array = [_controller database];
	row = [_tableView selectedRow];
	if (row != -1) {
		search = [array objectAtIndex:row];
		history = [search objectForKey:@"History"];
		history = (NSString*)CFURLCreateStringByAddingPercentEscapes( NULL, 
            (CFStringRef)history, NULL, CFSTR("+"), CFStringConvertNSStringEncodingToEncoding(NSUTF8StringEncoding));
		urlString = [NSString stringWithFormat:@"http://www.google.com/search?hl=ja&lr=lang_ja&ie=utf-8;&oe=utf-8;&q=%@", history];
		url = [NSURL URLWithString:urlString];
		[wspace openURL:url];
	}
}


- (IBAction)searchGoogle:(id)sender {
	[self openDoubleFile:self];
}

// デフォルトでは不可視になっています。(ADCから検索)
- (IBAction)searchGoogleADC:(id)sender {
	NSWorkspace *wspace = [NSWorkspace sharedWorkspace];
	NSString *history;
	NSMutableArray *array;	
	NSMutableDictionary *search;
	int row;
	NSURL *url;
	NSString *urlString;
	
	array = [_controller database];
	row = [_tableView selectedRow];
	if (row != -1) {
		search = [array objectAtIndex:row];
		history = [search objectForKey:@"History"];
		history = (NSString*)CFURLCreateStringByAddingPercentEscapes( NULL, 
            (CFStringRef)history, NULL, CFSTR("+"), CFStringConvertNSStringEncodingToEncoding(NSUTF8StringEncoding));
		urlString = [NSString stringWithFormat:@"http://developer.apple.com/cgi-bin/search.pl?&q=%@&num=10&ie=utf8&oe=utf8&lr=lang_en&simp=1", history];
		url = [NSURL URLWithString:urlString];
		[wspace openURL:url];
	}
}

// デフォルトでは不可視になっています。(Googleウェブ全体から検索)
- (IBAction)searchGoogleALL:(id)sender {
	NSWorkspace *wspace = [NSWorkspace sharedWorkspace];
	NSString *history;
	NSString *format;
	NSMutableArray *array;	
	NSMutableDictionary *search;
	int row;
	NSURL *url;
	NSString *urlString;
	
	array = [_controller database];
	row = [_tableView selectedRow];
	if (row != -1) {
		search = [array objectAtIndex:row];
		history = [search objectForKey:@"History"];
		history = (NSString*)CFURLCreateStringByAddingPercentEscapes( NULL, 
            (CFStringRef)history, NULL, CFSTR("+"), CFStringConvertNSStringEncodingToEncoding(NSUTF8StringEncoding));

		// 検索 = %E6%A4%9C%E7%B4%A2
		// 　format = http://www.google.com/search?q=%@&ie=UTF-8&hl=ja&btnG=Google+%E6%A4%9C%E7%B4%A2&lr=

		format = NSLocalizedString(@"GoogleALLURL",@"http://www.google.com/search?hl=ja&ie=UTF-8&q=%@&lr=");

//		urlString = [NSString stringWithFormat:format, history, NSLocalizedString(@"Search",@"")];
		urlString = [NSString stringWithFormat:@"http://www.google.com/search?hl=ja&ie=UTF-8&q=%@&lr=", history];

		url = [NSURL URLWithString:urlString];
		[wspace openURL:url];
	}
}

@end
